<template>
  <the-mask v-if="filterType === 'time'"
            mask="##:##"
            :masked="true"
            class="filter-input"
            :class="{
              'success': (value === 0 || value && String(value).length),
              'error': error
            }"
            :type="type"
            :placeholder="placeholder"
            :value="value"
            @input="onInput"
  />

  <input v-else
         class="filter-input"
         :class="{
           'success': (value === 0 || value && String(value).length),
           'error': error
         }"
         :type="type"
         :placeholder="placeholder"
         :value="value"
         @input="onInput"
  >
</template>

<script>
  import { TheMask } from 'vue-the-mask';

  export default {
    name: 'FilterInput',
    components: {TheMask},
    props: {
      filterType: {
        type: String,
        default: null
      },

      type: {
        type: String,
        default: 'text'
      },

      placeholder: {
        type: [String, Number],
        default: ''
      },

      value: {
        type: [String, Number],
        default: null
      },

      error: {
        type: Boolean,
        default: false,
      }
    },

    data: () => ({
      disableChange: false
    }),

    watch: {
      value(val) {
        if (val === null) {
          if (this.disableChange) {
            this.disableChange = false;
            return;
          }

          this.$emit('input', '');

          this.$nextTick(() => {
            this.$emit('input', null);

            this.disableChange = true;
          });
        }
      }
    },

    methods: {
      onInput(event) {
        if (event.target) {
          this.$emit('input', event.target.value)
        } else {
          this.$emit('input', event)
        }
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .filter-input {
    @include base-input;

    height: rem(50);
    padding: 0 rem(22);

    // Высота поля минус бордеры
    line-height: rem(46);

    &::placeholder {
      line-height: rem(46);
    }

    &.error {
      color: rgba($red, .6);
      border-color: rgba($red, .6) !important;
    }
  }
</style>
